(* lexer for my proofnet tool *)

{ 
open Parser
exception Eof
}

(* Very shitty input sets *)

let latex_macro = '\\'['A'-'Z' 'a'-'z']+
let s = ('^' latex_macro) | ('^' '*')
let w = ['A'-'Z']
let d = ['0'-'9']+

rule token = parse
    ' ' { token lexbuf }
| w { ATOM(Lexing.lexeme lexbuf) }
| s { SUPERSCRIPT(Lexing.lexeme lexbuf) }
| '(' { LPAREN }
| ')' { RPAREN } 
| ',' { COMMA }
| latex_macro { BINOP(Lexing.lexeme lexbuf)}
| d { DIGITS (int_of_string (Lexing.lexeme lexbuf))}
| '\t' { TAB }
| '\n' { EOL }
| eof { EOF }
