
%start proofnets
%type <Proofnettypes.proofnet list> proofnets


%token LPAREN RPAREN COMMA TAB EOL EOF
%token <string> ATOM 
%token <string> SUPERSCRIPT 
%token <string> BINOP
%token <int> DIGITS
%left BINOP 

%%

proofnets : proofnet proofnets { $1 :: $2 }
          | EOF                { [] } 

proofnet : fl TAB pl EOL { $1, $3 }

fl : f { $1 :: [] }
   | f COMMA fl { $1 :: $3 }

f : ATOM             { Proofnettypes.Atom $1 }
  | ATOM SUPERSCRIPT { Proofnettypes.Atom ($1 ^ $2) }
  | LPAREN f RPAREN  { $2 }
  | f BINOP f        { Proofnettypes.Binop($1,$3,$2) }

pl : p          { $1 :: [] }
   | p COMMA pl { $1 :: $3 }

p : LPAREN DIGITS COMMA DIGITS RPAREN { ($2, $4) }
;

%%
